# -*- coding: utf-8 -*-

import re

def convertOrd(char):
    if (char >= ord("a") and char <= ord("z")):
        return char - 32
    else:
        return char

def getSequences(password):
    sequences = []
    pos = 0
    while (pos < len(password)):
        charnum = 0
        try:
            charnum = ord(password[pos])
        except:
            pos += 1
            continue
        charnum = convertOrd(charnum)
        if ((charnum >= ord("A") and charnum <= ord("Z")) or (charnum >= ord("0") and charnum <= ord("9"))):
            x = 1
            seqlen = 0
            while (pos + x < len(password)):
                charnum2 = 0
                try:
                    charnum2 = ord(password[pos+x])
                except:
                    if (seqlen > 0):
                        sequences.append(seqlen)
                    x += 1
                    break
                charnum2 = convertOrd(charnum2)
                if (charnum + 1 == charnum2 and (charnum2 <= ord("Z") or charnum2 <= ord("9"))):
                    seqlen += 1
                    x += 1
                    charnum = charnum2
                else:    
                    break
            if (seqlen > 0):
                sequences.append(seqlen)
            pos += x
        else:
            pos += 1
    return sequences

def dictionaryCount(password):
    # Vrátí počet slov ve slovníku nalezených v hesle
    f = open("slovnik", "r")
    count = 0
    for line in f:
        line = line.rstrip("\n")
        #print line
        if (password.find(line) != -1):
            count += 1
    f.close()
    return count

def passwordStrength(password, username):
    # Vypočítá skóre od 0 do 100 pro dané heslo
    score = 0
    if (not (password == username or len(password) < 6)):
        score = len(password) * 4
        rep = 0
        repchars = 0
        pos = 0
        tested = []
        for i in password:
            if (not i in tested):
                tested.append(i)
                if (re.match("[\d\w]", i)):
                    count = len(re.findall(i, password[pos+1:]))
                    if (count > 0):
                        score -= count
                        rep += count
                        repchars += 1
            pos += 1
        score -= repchars
        if (repchars <= 2 and rep >= len(password)/2):
            score -= 15
        numcount = len(re.findall("\d", password))
        if (numcount >= 3):
            score += 5
        spcharscount = len(re.findall("[-.\[\]!@#&\,%\^&*?_~€\(\)<>}{°]", password))
        if (spcharscount >= 2):
            score += 5
        lowcasecount = len(re.findall("[a-z]", password))
        upcasecount = len(re.findall("[A-Z]", password))
        if (lowcasecount > 0 and upcasecount > 0):
            score += 5
        if (numcount > 0 and (lowcasecount > 0 or upcasecount > 0)):
            score += 5
        if (numcount > 0 and spcharscount > 0):
            score += 5
        if (spcharscount > 0 and (lowcasecount > 0 or upcasecount > 0)):
            score += 5
        if (lowcasecount + upcasecount == len(password)):
            score -= 10
        if (numcount == len(password)):
            score -= 10
        # Sekvence
        seq = getSequences(password)
        for i in seq:
            score -= (len(seq) +1) ** (i+1)
        seq = getSequences(password[::-1])
        for i in seq:
            score -= (len(seq) +1) ** (i+1)
        # Slovník
        score -= 20 * dictionaryCount(password)
        if (score > 100):
            score = 100
        elif (score < 0):
            score = 0
    return score
